<?php
	/*
		pdsql_msxml4.inc ver 0.7,0 2010/10/13
		Copyright (c) 2001-2002 Hideya Tanaka
	*/

	if(phpversion()>="5.1.0"){
		date_default_timezone_set('Asia/Tokyo');
	}

	function swap($array,$i,$j){
		$temp = $array[$i];
		$array[$i] = $array[$j];
		$array[$j] = $temp;
		return $array;
	}

	function pos_sort($key_array){
		$pos = array();
		$num = count($key_array);
		for($i=0;$i<$num;$i++){
			$pos[$i] = $i;
		}
		for($i=0;$i<$num;$i++){
			for($j=$i+1;$j<$num;$j++){
				if($key_array[$i] > $key_array[$j]){
					$key_array = swap($key_array,$i,$j);
					$pos = swap($pos,$i,$j);
				}
			}
		}
		return $pos;
	}
	function pos_sort_r($key_array){
		$pos = array();
		$num = count($key_array);
		for($i=0;$i<$num;$i++){
			$pos[$i] = $i;
		}
		for($i=0;$i<$num;$i++){
			for($j=$i+1;$j<$num;$j++){
				if($key_array[$i] < $key_array[$j]){
					$key_array = swap($key_array,$i,$j);
					$pos = swap($pos,$i,$j);
				}
			}
		}
		return $pos;
	}

	function set_NS_Property($con,$name){
		$dom = $con["dom"];
		$dom->setProperty("SelectionNamespaces", $name);
	}

	function pd_connect($filename){
		$file2 = $filename . ".lock";
		$maxwait = 20;
		$count = 0;
		while(file_exists($file2)){
			if($count >$maxwait){
				print "${filename}͌݃bNĎgpł܂\n";
				exit;
			}
			sleep(1);
			$count++;
		}
		$dom = new COM("Msxml2.DOMDocument.6.0")
			or die("Unable to instanciate Msxml2.DOMDocument.6.0");
		$dom->async=false;
		$dom->load($filename) 
			or die("${filename}t@Cǂݍ߂ȂXML̍\ُłB");

		$fcontents = file ($filename);				
		$num = 0;
		$ns = array();

		foreach ($fcontents as $line_num => $line){
//		while (list ($line_num, $line) = each ($fcontents)) {
			while(1){
				$pos = strpos($line,"xmlns");
				if(!is_long($pos) && !$pos) break;
				$line = substr($line,$pos);
				$c = "\"";
				$pos = strpos($line,$c);
				if(!is_long($pos) && !$pos){
					$pos = strpos($line,"'");
					$c = "'";
					if(!is_long($pos) && !$pos) die("l[Xy[XُłB${line_num}s");
				}
				$pos = strpos($line,$c,$pos+1);
				if(!is_long($pos) && !$pos) die("l[Xy[XُłB${line_num}s");
				$temp = substr($line,0,$pos+1);
				$flg = 0;
				for($i=0;$i<$num;$i++){
					if($ns[$i] == $temp){
						$flg = 1;
						break;
					}
				}
				if($flg == 0){
					$ns[$num] = $temp;
					$num++;
				}
				$line = substr($line,$pos);
			}
		}
		$name = "";
		for($i=0;$i<$num;$i++){
			$name .= " " . $ns[$i];
		}
		$dom->setProperty("SelectionNamespaces", $name);
//		print "name = $name <br>";

		$con["filename"] = $filename;
		$con["dom"] = $dom;
		return $con;
	}

	function pd_close($con){
		$dom = $con["dom"];
		$filename = $con["filename"];
		$dom->save($filename);
		// IuWFNgJ
		$dom = null;
		//ǂݏƂƐ`
		$dom = new COM("Msxml2.DOMDocument.6.0")
			or die("Unable to instanciate Msxml2.DOMDocument.6.0");
		$dom->async=false;
		$dom->load($filename) 
			or die("${filename}t@Cǂݍ߂ȂXML̍\ُłB");
		$dom->save($filename);
		$dom = null;
		$file2 = $filename . ".lock";
		if(file_exists($file2)){
			unlink($file2);
		}
	}

	function pd_lock(&$con){
		$filename = $con["filename"];
		$file2 = $filename . ".lock";
		$count = 0;
		$maxwait = 20;
		while(file_exists($file2)){
			if($count >$maxwait){
				print "${filename}͌݃bNĂ邽߃bNł܂\n";
				exit;
			}
			sleep(1);
			$count++;
		}
		$fp = fopen($file2,"w");
		if(!$fp){
			print "bNt@C݂̏ł܂\n";
			exit;
		}
		fwrite($fp,"lock");
		fclose($fp);
		if($count != 0){
			$dom = $con["dom"];
			$dom->load($filename) 
				or die("${filename}t@Cǂݍ߂ȂXML̍\ُłB");
			$con["dom"] = $dom;
		}
	}

	function where_tree($text){
		$len = strlen($text);
		$i = 0;
		$node_no = 1;
		$node_index = 1;
		$node = array();
		$node[0]["child_num"] = 1;
		$node[0]["child"][0] = 1;
		$node[0]["parent"] = -1;
		$node[1]["parent"] = 0;
		$node[1]["child_num"] = 0;
		$node[0]["calc"] = "";
		$node[1]["calc"] = "";
		$node[0]["L"]="";
		$node[0]["R"]="";
		$node[1]["L"]="";
		$node[1]["R"]="";
		$node[0]["not"] = 0;
		$node[1]["not"] = 0;
		$node[0]["func"][0]="";
		$node[1]["func"][0]="";
		$string_flg = 0;
		$r_flg = 0;
		while($i < $len){
			$c = substr($text,$i,1);
			$c2 = substr($text,$i,2);
			$c3 = substr($text,$i,3);
			$c4 = substr($text,$i,4);
			if($string_flg == 0){
				if($c == " "){
					$i++;
				}else if($c == "!"){
					$node[$node_index]["not"] = 1;
					$i++;
				}else if(!strcasecmp($c3,"not")){
					$node[$node_index]["not"] = 1;
					$i += 3;
				}else if(!strcasecmp($c3,"and")){
					$node_index = $node[$node_index]["parent"];
					$index = $node[$node_index]["child_num"]-1;
					$node[$node_index]["func"][$index] = "*";
					$index++;
					$node[$node_index]["child_num"]= $index+1;
					$node_no++;
					$node[$node_index]["child"][$index] = $node_no;
					$node[$node_no]["parent"] = $node_index;
					$node_index = $node_no;
					$node[$node_no]["child_num"] = 0;
					$node[$node_no]["not"] = 0;
					$node[$node_no]["L"]="";
					$node[$node_no]["R"]="";
					$node[$node_no]["func"][0]="";
					$r_flg=0;
					$node[$node_index]["calc"] = "";
					$i += 3;
				}else if(!strcasecmp($c2,"or")){
					$node_index = $node[$node_index]["parent"];
					$index = $node[$node_index]["child_num"]-1;
					$node[$node_index]["func"][$index] = "+";
					$index++;
					$node[$node_index]["child_num"]= $index+1;
					$node_no++;
					$node[$node_index]["child"][$index] = $node_no;
					$node[$node_no]["parent"] = $node_index;
					$node_index = $node_no;
					$node[$node_no]["child_num"] = 0;
					$node[$node_no]["not"] = 0;
					$node[$node_no]["L"]="";
					$node[$node_no]["R"]="";
					$node[$node_no]["func"][0]="";
					$r_flg=0;
					$node[$node_index]["calc"] = "";
					$i += 2;
				}else if($c == "("){
					$index = $node[$node_index]["child_num"]-1;
					$index++;
					$node[$node_index]["child_num"]= $index+1;
					$node_no++;
					$node[$node_index]["child"][$index] = $node_no;
					$node[$node_no]["parent"] = $node_index;
					$node_index = $node_no;
					$node[$node_no]["child_num"] = 0;
					$node[$node_no]["L"]="";
					$node[$node_no]["R"]="";
					$node[$node_no]["not"] = 0;
					$node[$node_no]["func"][0]="";
					$r_flg=0;
					$node[$node_index]["calc"] = "";
					$i ++;
				}else if($c == ")"){
					$node_index = $node[$node_index]["parent"];
					$i ++;
				}else if(!strcasecmp($c4,"like")){
					$node[$node_index]["calc"] = "like";
					$r_flg = 1;
					$i += 4;
				}else if($c2 == "<="){
					$node[$node_index]["calc"] = "<=";
					$r_flg = 1;
					$i += 2;
				}else if($c2 == ">="){
					$node[$node_index]["calc"] = ">=";
					$r_flg = 1;
					$i += 2;
				}else if($c2 == "<>"){
					$node[$node_index]["calc"] = "<>";
					$r_flg = 1;
					$i += 2;
				}else if($c == "="){
					$node[$node_index]["calc"] = "=";
					$r_flg = 1;
					$i++;
				}else if($c == "<"){
					$node[$node_index]["calc"] = "<";
					$r_flg = 1;
					$i++;
				}else if($c == ">"){
					$node[$node_index]["calc"] = ">";
					$r_flg = 1;
					$i++;
				}else if($c == "'"){
					$string_flg = 1;
					$i++;
				}else{
					if($r_flg == 0){
						$node[$node_index]["L"] .= $c;
					}else{
						$node[$node_index]["R"] .= $c;
					}
					$i++;
				}
			}else{
				if($c == "'"){
					$string_flg = 0;
//					$i++;
				}else if($r_flg == 0){
					$node[$node_index]["L"] .= $c;
				}else{
					$node[$node_index]["R"] .= $c;
				}
				$i++;
			}
		}
		$node["num"] = $node_no+1;
		return $node;
	}

	function calc_check($left,$right,$calc){
		$check = 0;
		if($calc == "like"){
			$len = strlen($right);
			$c = substr($right,0,1);
			if($c == '%'){						//v
				$sub = substr($right,1);
				$len = strlen($sub);
				$len2 = strlen($left);
				$pos = $len2 - $len;
				if($pos >= 0){
					$sub_l = substr($left,$pos);
					if($sub == $sub_l){
						$check = 1;
					}
				}
			}else{
				$c = substr($right,$len-1);
				if($c == '%'){					//Ov
					$sub = substr($right,0,$len-1);
					$len2 = strlen($sub);
					$sub_l = substr($left,0,$len2);
					if($sub_l == $sub){
						$check = 1;
					}
				}else if($left == $right){
					$check = 1;
				}
			}
		}else if($calc == "="){
			if($left == $right){
				$check = 1;
			}
		}else if($calc == "<"){
			if($left < $right){
				$check = 1;
			}
		}else if($calc == ">"){
			if($left > $right){
				$check = 1;
			}
		}else if($calc == "<="){
			if($left <= $right){
				$check = 1;
			}
		}else if($calc == ">="){
			if($left >= $right){
				$check = 1;
			}
		}else if($calc == "<>"){
			if($left != $right){
				$check = 1;
			}
		}
		return $check;
	}
		

	function calc_node($node,$id,$dom_node){
		$node_name = $node[$id]["L"];
		$node_value = $node[$id]["R"];
		$node_calc = $node[$id]["calc"];
		$temp = preg_split("/\//",$node_name);
		$count = count($temp);
		$c = substr($temp[$count-1],0,1);			//`FbN 
		if($c != '@') {
			if($node_name == '#value'){				//^[Qbgm[h̒l
				$child_value = $dom_node->text;
				$check = calc_check($child_value,$node_value,$node_calc);
			}else{
				$node_array = $dom_node->selectNodes($node_name);
				$num = $node_array->length;
				$check = 0;
				for($i=0;$i<$num;$i++){
					$child = $node_array->item($i);
					$child_value= $child->text;
					$check = calc_check($child_value,$node_value,$node_calc);
					if($check == 1){
						break;
					}
				}
			}
		}else{
			$pos = strpos($node_name,"@");
			$attrib_name = substr($node_name,$pos+1);
			$node_name = substr($node_name,0,$pos-1);
			if($pos == 0){
				$attribs = $dom_node->attributes;
				$attrib_node = $attribs->getNamedItem($attrib_name);
				$attrib = $attrib_node->nodeValue;
//				$attrib = $dom_node->getAttribute($attrib_name);
				$check = calc_check($attrib,$node_value,$node_calc);
			}else{
				$node_array = $dom_node->selectNodes($node_name);
				$num = $node_array->length;
				$check = 0;
				for($i=0;$i<$num;$i++){
					$child = $node_array->item($i);
//					$attrib = $child->getAttribute($attrib_name);
					$attribs = $child->attributes;
					$attrib_node = $attribs->getNamedItem($attrib_name);
					$attrib = $attrib_node->nodeValue;
					$check = calc_check($attrib,$node_value,$node_calc);
					if($check == 1){
						break;
					}
				}
			}
		}
		if($node[$id]["not"] == 1){
			if($check == 1){
				$check = 0;
			}else{
				$check = 1;
			}
		}
		return $check;
	}

	function calc_from_child($node,$id){
		$num = $node[$id]["child_num"];
		$child = $node[$id]["child"][0];
		$value = $node[$child]["value"];
		for($i=1;$i<$num;$i++){
			$func = $node[$id]["func"][$i-1];
			$child2 = $node[$id]["child"][$i];
			$value2 = $node[$child2]["value"];
			if($func == "*"){
				$value = $value * $value2;
			}else if($func == "+"){
				$value = $value + $value2;
			}
		}
		if($node[$id]["not"] == 1){
			if($value > 0){
				$value = 0;
			}else{
				$value = 1;
			}
		}else{
			if($value > 0){
				$value = 1;
			}
		}
		return $value;
	}

			
	function where_calc($node,$dom_node){
		$child_array = array();
		
		$level=0;
		$child_end = false;
		$child_array["child_id"][0] = 0;
		$child_array["child_index"][0] = 0;

		while(1){
			$id = $child_array["child_id"][$level];				//@childe_arrayid荞
			if($child_end){										//@qnodȅIꍇ
				$child_end = false;
				$node[$id]["value"]=calc_from_child($node,$id);	//	qnode̒l玩̒lvZ
				if($level == 0){								//@[g̏ꍇ̏I
					break;
				}
				$parent = $child_array["child_id"][$level-1];	//@enode
				$index = $child_array["child_index"][$level];	//@index
				$num2 = $node[$parent]["child_num"];			//@Ɠx̎qnode̐
				$index++;										//@̎̎qnodeindex
				if($index == $num2){							//@Ō̎qnodȅꍇ
					$level--;									//@enodẽxxɂ
					$child_end = true;							//@qnodȅI
				}else{											//@܂̎qnodeꍇ
					$id = $node[$parent]["child"][$index];		//	̎̎qnodeid		
					$child_array["child_id"][$level] = $id;		//	child_arrayɏ
					$child_array["child_index"][$level] = $index;
				}
			}else{
				$num = $node[$id]["child_num"];					//@̎qnode̐
				if($num != 0){									//@qnodeꍇ
					$level++;									//@qnodẽxxɂ
					$child_array["child_id"][$level] = $node[$id]["child"][0];	//@qnode̐擪id
					$child_array["child_index"][$level] = 0;
				}else{											//@qnodeꍇ
					$node[$id]["value"]= calc_node($node,$id,$dom_node);		//	vZ̎s
					$parent = $child_array["child_id"][$level-1];	//@enodeid
					$index = $child_array["child_index"][$level];	//@index
					$num2 = $node[$parent]["child_num"];		//@Ɠx̎qnode̐
					$index++;									//@̎̎qnodeindex
					if($index == $num2){						//@Ō̎qnodȅꍇ
						$level--;								//@enodẽxxɂ
						$child_end = true;						//@qnodȅI
					}else{										//@܂̎qnodeꍇ
						$id = $node[$parent]["child"][$index];	//	̎̎qnodeid
						$child_array["child_id"][$level] = $id;	//	child_arrayɏ
						$child_array["child_index"][$level] = $index;
					}
				}
			}
		}
		return $node[0]["value"];
	}


	function sql_analyze($sql){
		$sql = trim($sql);
		$string = preg_split("/ /",$sql);
		$num = count($string);
		$where = -1;
		$order = -1;
		$desc = -1;
		$name = "";
		$obj = "";
		$table = "";
		$values = "";
		$cmd = $string[0];
		if($cmd == "select"){
			for($i=1;$i<$num;$i++){
				if($string[$i] == "from"){
					break;
				}else{
					$obj .= $string[$i];
				}
			}
			for($j=$i+1;$j<$num;$j++){
				if($string[$j] != ""){	
					$table = $string[$j];
					break;
				}
			}
			for($k=$j+1;$k<$num;$k++){
				if($string[$k] != ""){
					if($string[$k] == "where"){
						$where = 1;
						break;
					}
				}
			}
			if($where == 1){
				$where = "";
				for($l=$k+1;$l<$num;$l++){
					if($string[$l] == "order"){
						$order = 1;
						break;
					}
					$where .= $string[$l];
				}
				if($order == 1){
					for($m=$l+1;$m<$num;$m++){
						if(($string[$m] != "")&&($string[$m] != "by")){
							if($string[$m] == "DESC"){
								$desc = 1;
							}else if($string[$l] == "desc"){
								$desc = 1;
							}else{
								$order = $string[$m];
							}
						}
					}
				}
			}else{
				for($k=$j+1;$k<$num;$k++){
					if($string[$k] == "order"){
						$order = 1;
						break;
					}
				}
				if($order == 1){
					for($l=$k+1;$l<$num;$l++){
						if(($string[$l] != "")&&($string[$l] != "by")){
							if($string[$l] == "DESC"){
								$desc = 1;
							}else if($string[$l] == "desc"){
								$desc = 1;
							}else{
								$order = $string[$l];
							}
						}
					}
				}
			}
		}else if($cmd == "insert"){
			for($i=1;$i<$num;$i++){
				if($string[$i] == "into"){
					break;
				}
			}
			for($j=$i+1;$j<$num;$j++){
				if($string[$j] != ""){	
					$table = $string[$j];
					break;
				}
			}
			for($k=$j+1;$k<$num;$k++){
				if($string[$k] != ""){
					if($string[$k] == "values"){
						break;
					}
					$obj .= $string[$k];
				}
			}
			$pos = strpos($obj,")");
//			$name = substr($obj,$pos+1);
//			$temp = split("=",$name);
//			$name = $temp[1];
//			$name = ereg_replace("'","",$name);
			$obj = substr($obj,0,$pos+1);
			$obj = preg_replace("/\(/","",$obj);
			$obj = preg_replace("/\)/","",$obj);
			for($l=$k+1;$l<$num;$l++){
				if($string[$l] != ""){
					$values .= $string[$l];
				}
			}
			$values = preg_replace("/\(/","",$values);
			$values = preg_replace("/\)/","",$values);
		}else if($cmd == "update"){
			for($i=1;$i<$num;$i++){
				if($string[$i] == "set"){
					break;
				}
				if($string[$i] != ""){
					$table = $string[$i];
				}
			}
			for($j=$i+1;$j<$num;$j++){
				if($string[$j] == "where"){	
					$where = 1;
					break;
				}
				$obj .= $string[$j];
			}
			if($where == 1){
				$where = "";
				for($k=$j+1;$k<$num;$k++){
					if($string[$k] != ""){
						$where .= $string[$k];
					}
				}
			}
		}else if($cmd == "delete"){
			for($i=1;$i<$num;$i++){
				if($string[$i] == "from"){
					break;
				}
			}
			for($j=$i+1;$j<$num;$j++){
				if($string[$j] == "where"){	
					$where = 1;
					break;
				}
				if($string[$j] != ""){
					$table = $string[$j];
				}
			}
			if($where == 1){
				$where = "";
				for($k=$j+1;$k<$num;$k++){
					if($string[$k] != ""){
						$where .= $string[$k];
					}
				}
			}
		}
		$analyze = array();
		$analyze["cmd"] = $cmd;
		$analyze["table"] = $table;
		$analyze["obj"] = $obj;
		$analyze["where"] = $where;
		$analyze["order"] = $order;
		$analyze["desc"] = $desc;
		$analyze["values"] = $values;
		$analyze["name"] = $name;
		return $analyze;
	}
	
	function order_sort($dom,$node_array,$analyze){
		if($analyze["order"] == -1){
			return $node_array;
		}
		$num = $node_array["num"];
		$order_array = array();
		$order_array2 = array();
		$obj = $analyze["order"];
		$temp = preg_split("/\//",$obj);
		$count = count($temp);
		$c = substr($temp[$count-1],0,1);			//`FbN 
		if($c != '@') {
			for($i=0;$i<$num;$i++){
				$dom_node = $node_array[$i];
				$dom_node = $dom_node->selectSingleNode($obj);
				$order_array[$i] = $dom_node->text;
			}
		}else{
			$pos = strpos($obj,"@");
			$attrib_name = substr($obj,$pos+1);
			if($pos != 0){
				$node_name = substr($obj,0,$pos-1);
			}
			for($i=0;$i<$num;$i++){
				$dom_node = $node_array[$i];
				if($pos != 0){
					$dom_node = $dom_node->selectSingleNode($node_name);
				}
//				$order_array[$i] = $dom_node->getAttribute($attrib_name);
				$attribs = $dom_node->attributes;
				$attrib_node = $attribs->getNamedItem($attrib_name);
				$order_array[$i] = $attrib_node->nodeValue;
			}
		}
		if($analyze["desc"] == 1){
			$order_array = pos_sort_r($order_array);
		}else{
			$order_array = pos_sort($order_array);
		}
		for($i=0;$i<$num;$i++){
			$order_array2[$i] = $node_array[$order_array[$i]];
		}
		$order_array2["num"] = $num;
		return $order_array2;
	}

	function pd_select($dom,$analyze){
//		$table = $dom->selectSingleNode($analyze["table"]);
		$node_name = $analyze["table"];
		$node_array = array();
		$node_array = $dom->selectNodes($node_name);
		$num = $node_array->length;
		$result = array();
		if($analyze["where"] == -1){
			for($i=0;$i<$num;$i++){
				$result[$i] = $node_array->item($i);
			}
			$result["num"] = $num;
		}else{
			$where = where_tree($analyze["where"]);
			$index = 0;
			for($i=0;$i<$num;$i++){
				$dom_node = $node_array->item($i);
				$check = where_calc($where,$dom_node);
				if($check == 1){
					$result[$index]= $dom_node;
					$index++;
				}
			}
			$result["num"] = $index;
		}
		$result = order_sort($dom,$result,$analyze);
		return $result;
	}
	function pd_insert(&$dom,$analyze){
		$tmp_array = array();
		$table = $analyze["table"];
		$pos = strrpos($table,"/");
		$ind_org = "";
		$ind_org2 = "";
		if(!is_long($pos) && !$pos){
			$name = $table;
			$table = $dom->documentElement;
		}else{
			$name = substr($table,$pos+1);
			$table = substr($table,0,$pos);
			$dummy = preg_split("/\//",$table);
			$ind_num = count ($dummy);
			for($i=0;$i<$ind_num;$i++){
				$ind_org .= "\t";
			}
			$table = $dom->selectSingleNode($table);
		}
		$tmp_array = $table->childNodes;
		$num = $tmp_array->length;
		for($i=$num-1;$i>0;$i--){
			$tmp_node = $tmp_array->item($i);
			if($tmp_node->nodeType != 3) break;
		}
		if($i != $num-1){
			$last = $i + 1;
			$last_node = $tmp_array->item($last);
			$lf = $dom->createTextNode("\n");
			$table->insertBefore($lf,$last_node);
			$indent = $dom->createTextNode($ind_org);
			$table->insertBefore($indent,$last_node);
		}else{
			$lf = $dom->createTextNode("\n");
			$table->appendChild($lf);
			$indent = $dom->createTextNode($ind_org);
			$table->appendChild($indent);
		}
		$dom_node = $dom->createElement($name);
		$table->appendChild($dom_node);
		for($i=0;$i<$ind_num-1;$i++){
			$ind_org2 .= "\t";
		}
		$lf = $dom->createTextNode("\n");
		$table->appendChild($lf);
		$indent = $dom->createTextNode($ind_org2);
		$table->appendChild($indent);
		$lf = $dom->createTextNode("\n");
		$dom_node->appendChild($lf);
		$indent = $dom->createTextNode($ind_org);
		$dom_node->appendChild($indent);
		$obj = preg_split("/,/",$analyze["obj"]);
		$ana = $analyze["obj"];
		$num = count($obj);
		$values = preg_split("/,/",$analyze["values"]);
		$child_array = array();
		$node_array = array();
		for($i=0;$i<$num;$i++){
			$temp = preg_split("/\//",$obj[$i]);
			$num2 = count($temp);
			$dom_node2 = $dom_node;
			$value = $values[$i];
			$value = preg_replace("/'/","",$value);
			for($j=0;$j<$num2-1;$j++){
				$node_name = $temp[$j];
//				$child_array = $dom_node2->selectNodes($node_name);
//				$num3 = $child_array->length;
				$tmp_array = $dom_node2->childNodes;
				$num3 = $tmp_array->length;
				$last = $num3 -2;
				$flg = 0;
				for($m=0;$m<$num3;$m++){
					$tmp1 = $tmp_array->item($m);
					if($tmp1->nodeType ==1){
						$tmp_name = $tmp1->nodeName;
						if($tmp_name == $node_name){
							$flg = 1;
							$dom_node2 = $tmp1;
							break;
						}
					}
				}
				if($flg == 0){
					$last_node = $tmp_array->item($last);
					$lf = $dom->createTextNode("\n");
					$dom_node2->insertBefore($lf,$last_node);
					$indent = $ind_org ;
					$indent = $dom->createTextNode($indent);
					$dom_node2->insertBefore($indent,$last_node);
					for($l = $j;$l<$num2 - 1;$l++){
						$node_name = $temp[$l];
						$indent = $dom->createTextNode("\t");
						$dom_node2->insertBefore($indent,$last_node);
						$dom_node3 = $dom->createElement($node_name);
						$dom_node2->insertBefore($dom_node3,$last_node);
						$lf = $dom->createTextNode("\n");
						$dom_node3->appendChild($lf);
						$indent = $ind_org . "\t";
						for($k=0;$k<$j;$k++){
							$indent .= "\t";
						}
						$indent = $dom->createTextNode($indent);
						$dom_node3->appendChild($indent);
						$dom_node2 = $dom_node3;
					}
					break;
				}
			}
			$c = substr($temp[$num2-1],0,1);
			if($c == '@'){
				$attrib_name = substr($temp[$num2-1],1);
				$dom_node2->setAttribute($attrib_name, $value);
			}else{
				$node_name = $temp[$num2-1];
				if($node_name != '#value'){			//^[Qbgm[h̒l
//					$child_array = $dom_node2->selectNodes($node_name);
//					$num4 = $child_array->length;
					$tmp_array = $dom_node2->childNodes;
					$num3 = $tmp_array->length;
					$last = $num3 -2;
					$flg = 0;
					for($m=0;$m<$num3;$m++){
						$tmp1 = $tmp_array->item($m);
						if($tmp1->nodeType ==1){
							$tmp_name = $tmp1->nodeName;
							if($tmp_name == $node_name){
								$flg = 1;
								$dom_node2 = $tmp1;
								break;
							}
						}
					}
					if($flg == 0){
						$last_node = $tmp_array->item($last);
						$lf = $dom->createTextNode("\n");
						$dom_node2->insertBefore($lf,$last_node);
						$indent = $ind_org . "\t" ;
						for($k=0;$k<$j;$k++){
							$indent .= "\t";
						}
						$indent = $dom->createTextNode($indent);
						$dom_node2->insertBefore($indent,$last_node);
						$dom_node3 = $dom->createElement($node_name);
						$dom_node2->insertBefore($dom_node3,$last_node);
						$lf = $dom->createTextNode("\n");
						$dom_node3->appendChild($lf);
						$indent = $ind_org . "\t";
						for($k=0;$k<$j;$k++){
							$indent .= "\t";
						}
						$indent = $dom->createTextNode($indent);
						$dom_node3->appendChild($indent);
						$dom_node2 = $dom_node3;
					}
				}
				$dom_node2->text = $value;
			}
		}
		return 1;
	}

	function pd_update(&$dom,$analyze){
		$flg = 1;
		$result = pd_select($dom,$analyze);
		$num = $result["num"];
		if($num == 0){
			$flg = -1;
		}
		$obj = array();
		$obj = preg_split("/,/",$analyze["obj"]);
		$num2 = count($obj);
		for($i=0;$i<$num2;$i++){
			$tmp = preg_split("/=/",$obj[$i]);
			$obj["L"][$i] = $tmp[0];
			$obj["R"][$i] = preg_replace("/'/","",$tmp[1]);
		}
		$node_array = array();
		for($i=0;$i<$num;$i++){
			$dom_node = $result[$i];
			for($j=0;$j<$num2;$j++){
				$node_array = $dom_node->selectNodes($obj["L"][$j]);
				$num3 = $node_array->length;
				if($num3 == 0){
					$flg = -1;
				}
				for($k=0;$k<$num3;$k++){
					$dom_node2 = $node_array->item($k);
					$dom_node2->text = $obj["R"][$j];
				}
			}
		}
		return $flg;
	}

	function pd_delete(&$dom,$analyze){
		$flg = 1;
		$result = pd_select($dom,$analyze);
		$num = $result["num"];
		if($num == 0){
			$flg = -1;
		}
		$table = $analyze["table"];
		$table = $dom->selectSingleNode($table);
		$table = $table->parentNode;
		for($i=0;$i<$num;$i++){
			$dom_node = $result[$i];
			$table->removeChild($dom_node);
		}
		return $flg;
	}

	function pd_exec(&$con,$sql){
		$dom = $con["dom"];
		$analyze = sql_analyze($sql);
		$cmd = $analyze["cmd"];
		$result = "";
		if($cmd == "select"){
			$result = pd_select($dom,$analyze);
		}else if($cmd == "insert"){
			$result = pd_insert($dom,$analyze);
			$con["dom"] = $dom;
		}else if($cmd == "update"){
			$result = pd_update($dom,$analyze);
			$con["dom"] = $dom;
		}else if($cmd == "delete"){
			$result = pd_delete($dom,$analyze);
			$con["dom"] = $dom;
		}
		return $result;
	}

	function pd_result($result,$con,$col,$obj){
//		return -1;
		$dom = $con["dom"];
		$dom_node = $result[$col];
		$value = array();
		$node_array = array();

		$temp = preg_split("/\//",$obj);
		$count = count($temp);
		$c = substr($temp[$count-1],0,1);			//`FbN 
		if($c != '@') {
			if($obj == '#value'){
				$value = $dom_node->text;
			}else{
				for($i=0;$i<$count-1;$i++){
//					$nodelist = $dom_node->getElementsByTagName($temp[$i]);
					$nodelist = $dom_node->selectNodes($temp[$i]);
					$dom_node = $nodelist->item(0);
				}
				$dom_node = $dom_node->selectSingleNode($temp[$count-1]);
				$value = $dom_node->text;
			}
		}else{
			$pos = strpos($obj,"@");
			$attrib_name = substr($obj,$pos+1);
			if($pos == 0){
				$child_node = $dom_node;
			}else{
				for($i=0;$i<$count-1;$i++){
//					$nodelist = $dom_node->getElementsByTagName($temp[$i]);
					$dom_node = $nodelist->item(0);
				}
			}
//			$value[$i] = $child_node->getAttribute($attrib_name);
			$attribs = $dom_node->attributes;
			$attrib_node = $attribs->getNamedItem($attrib_name);
			$value = $attrib_node->nodeValue;
		}
		return $value;
	}
	function pd_result_array($result,$con,$col,$obj){
		$dom = $con["dom"];
		$dom_node = $result[$col];
		$value = array();
		$node_array = array();

		$temp = preg_split("/\//",$obj);
		$count = count($temp);
		$c = substr($temp[$count-1],0,1);			//`FbN 
		if($c != '@') {
			if($obj == '#value'){
				$value[0] = $dom_node->text;
				$value["num"] = 1;
			}else{
				$node_array = array();
				$node_array_sub = array();
				$node_array[0] = $dom_node;
				for($i=0;$i<$count-1;$i++){
					$node_array_sub_su = count($node_array_sub);
					for($k=0;$k<$node_array_sub_su;$k++){
						$node_array_sub[$k] = "";
					}
					$node_array_su = count($node_array);
					for($k=0;$k<$node_array_su;$k++){
						$node_array_sub[$k] = $node_array[$k];
						$node_array[$k] = "";
					}
					$child = 0;
					for($k=0;$k<$node_array_su;$k++){
						$dom_node = $node_array_sub[$k];
						$nodelist = $dom_node->selectNodes($temp[$i]);
	//					$nodelist = $dom_node->getElementsByTagName($temp[$i]);
						$num = $nodelist->length;
						for($j=0;$j<$num;$j++){
							$node_array[$child] = $nodelist->item($j);
							$child ++;
						}
					}
				}
				if($child == 0){
					$dummy = array();
					$node_array = $dummy;
				}
				$node_array_su = count($node_array);
				$num = 0;
				for($j=0;$j<$node_array_su;$j++){
					$dom_node = $node_array[$j];
					$node_array_sub = $dom_node->selectNodes($temp[$count-1]);
					$num2 = $node_array_sub->length;
					for($i=0;$i<$num2;$i++){
						$dom_node = $node_array_sub->item($i);
						$value[$num] = $dom_node->text;
						$num++;
					}
				}
				$value["num"] = $num;
			}
		}else{
			$pos = strpos($obj,"@");
			$attrib_name = substr($obj,$pos+1);
			if($pos == 0){
				$node_array[0] = $dom_node;
			}else{
				$node_array = array();
				$node_array_sub = array();
				$node_array[0] = $dom_node;
				for($i=0;$i<$count-1;$i++){
					$node_array_sub_su = count($node_array_sub);
					for($k=0;$k<$node_array_sub_su;$k++){
						$node_array_sub[$k] = "";
					}
					$node_array_su = count($node_array);
					for($k=0;$k<$node_array_su;$k++){
						$node_array_sub[$k] = $node_array[$k];
						$node_array[$k] = "";
					}
					$child = 0;
					for($k=0;$k<$node_array_su;$k++){
						$dom_node = $node_array_sub[$k];
						$nodelist = $dom_node->selectNodes($temp[$i]);
//						$nodelist = $dom_node->getElementsByTagName($temp[$i]);
						$num = $nodelist->length;
						for($j=0;$j<$num;$j++){
							$node_array[$child] = $nodelist->item($j);
							$child ++;
						}
					}
				}
				if($child == 0){
					$dummy = array();
					$node_array = $dummy;
				}
			}
			$num = count($node_array);
			for($i=0;$i<$num;$i++){
				$child_node = $node_array[$i];
//				$value[$i] = $child_node->getAttribute($attrib_name);
				$attribs = $child_node->attributes;
				$attrib_node = $attribs->getNamedItem($attrib_name);
				$value[$i] = $attrib_node->nodeValue;
			}
			$value["num"] = $num;
		}
		return $value;
	}

?>
